#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
constant_9 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     PAM_ABORT PAM_RHOST PAM_RUSER */
  /* Offset 7 gives the best switch position.  */
  switch (name[7]) {
  case 'E':
    if (memEQ(name, "PAM_RUSER", 9)) {
    /*                      ^       */
      *iv_return = PAM_RUSER;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "PAM_ABORT", 9)) {
    /*                      ^       */
      *iv_return = PAM_ABORT;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "PAM_RHOST", 9)) {
    /*                      ^       */
      *iv_return = PAM_RHOST;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_11 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     PAM_AUTHTOK PAM_BUF_ERR PAM_SERVICE PAM_SUCCESS */
  /* Offset 10 gives the best switch position.  */
  switch (name[10]) {
  case 'E':
    if (memEQ(name, "PAM_SERVIC", 10)) {
    /*                         E      */
      *iv_return = PAM_SERVICE;
      return PERL_constant_ISIV;
    }
    break;
  case 'K':
    if (memEQ(name, "PAM_AUTHTO", 10)) {
    /*                         K      */
      *iv_return = PAM_AUTHTOK;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "PAM_BUF_ER", 10)) {
    /*                         R      */
      *iv_return = PAM_BUF_ERR;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "PAM_SUCCES", 10)) {
    /*                         S      */
      *iv_return = PAM_SUCCESS;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_12 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     PAM_AUTH_ERR PAM_BAD_ITEM PAM_CONV_ERR PAM_CRED_ERR PAM_MAXTRIES
     PAM_OPEN_ERR PAM_XDISPLAY */
  /* Offset 7 gives the best switch position.  */
  switch (name[7]) {
  case 'D':
    if (memEQ(name, "PAM_CRED_ERR", 12)) {
    /*                      ^           */
      *iv_return = PAM_CRED_ERR;
      return PERL_constant_ISIV;
    }
    break;
  case 'H':
    if (memEQ(name, "PAM_AUTH_ERR", 12)) {
    /*                      ^           */
      *iv_return = PAM_AUTH_ERR;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "PAM_OPEN_ERR", 12)) {
    /*                      ^           */
      *iv_return = PAM_OPEN_ERR;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "PAM_XDISPLAY", 12)) {
    /*                      ^           */
      *iv_return = PAM_XDISPLAY;
      return PERL_constant_ISIV;
    }
    break;
  case 'T':
    if (memEQ(name, "PAM_MAXTRIES", 12)) {
    /*                      ^           */
      *iv_return = PAM_MAXTRIES;
      return PERL_constant_ISIV;
    }
    break;
  case 'V':
    if (memEQ(name, "PAM_CONV_ERR", 12)) {
    /*                      ^           */
      *iv_return = PAM_CONV_ERR;
      return PERL_constant_ISIV;
    }
    break;
  case '_':
    if (memEQ(name, "PAM_BAD_ITEM", 12)) {
    /*                      ^           */
      *iv_return = PAM_BAD_ITEM;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_13 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     PAM_ERROR_MSG PAM_TEXT_INFO PAM_TRY_AGAIN PAM_XAUTHDATA */
  /* Offset 6 gives the best switch position.  */
  switch (name[6]) {
  case 'R':
    if (memEQ(name, "PAM_ERROR_MSG", 13)) {
    /*                     ^             */
      *iv_return = PAM_ERROR_MSG;
      return PERL_constant_ISIV;
    }
    break;
  case 'U':
    if (memEQ(name, "PAM_XAUTHDATA", 13)) {
    /*                     ^             */
      *iv_return = PAM_XAUTHDATA;
      return PERL_constant_ISIV;
    }
    break;
  case 'X':
    if (memEQ(name, "PAM_TEXT_INFO", 13)) {
    /*                     ^             */
      *iv_return = PAM_TEXT_INFO;
      return PERL_constant_ISIV;
    }
    break;
  case 'Y':
    if (memEQ(name, "PAM_TRY_AGAIN", 13)) {
    /*                     ^             */
      *iv_return = PAM_TRY_AGAIN;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_14 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     PAM_CONV_AGAIN PAM_FAIL_DELAY PAM_INCOMPLETE PAM_OLDAUTHTOK PAM_SYMBOL_ERR
     PAM_SYSTEM_ERR */
  /* Offset 6 gives the best switch position.  */
  switch (name[6]) {
  case 'C':
    if (memEQ(name, "PAM_INCOMPLETE", 14)) {
    /*                     ^              */
      *iv_return = PAM_INCOMPLETE;
      return PERL_constant_ISIV;
    }
    break;
  case 'D':
    if (memEQ(name, "PAM_OLDAUTHTOK", 14)) {
    /*                     ^              */
      *iv_return = PAM_OLDAUTHTOK;
      return PERL_constant_ISIV;
    }
    break;
  case 'I':
    if (memEQ(name, "PAM_FAIL_DELAY", 14)) {
    /*                     ^              */
      *iv_return = PAM_FAIL_DELAY;
      return PERL_constant_ISIV;
    }
    break;
  case 'M':
    if (memEQ(name, "PAM_SYMBOL_ERR", 14)) {
    /*                     ^              */
      *iv_return = PAM_SYMBOL_ERR;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "PAM_CONV_AGAIN", 14)) {
    /*                     ^              */
      *iv_return = PAM_CONV_AGAIN;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "PAM_SYSTEM_ERR", 14)) {
    /*                     ^              */
      *iv_return = PAM_SYSTEM_ERR;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_15 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     PAM_AUTHTOK_ERR PAM_PERM_DENIED PAM_SERVICE_ERR PAM_SESSION_ERR
     PAM_USER_PROMPT */
  /* Offset 7 gives the best switch position.  */
  switch (name[7]) {
  case 'H':
    if (memEQ(name, "PAM_AUTHTOK_ERR", 15)) {
    /*                      ^              */
      *iv_return = PAM_AUTHTOK_ERR;
      return PERL_constant_ISIV;
    }
    break;
  case 'M':
    if (memEQ(name, "PAM_PERM_DENIED", 15)) {
    /*                      ^              */
      *iv_return = PAM_PERM_DENIED;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "PAM_USER_PROMPT", 15)) {
    /*                      ^              */
      *iv_return = PAM_USER_PROMPT;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "PAM_SESSION_ERR", 15)) {
    /*                      ^              */
      *iv_return = PAM_SESSION_ERR;
      return PERL_constant_ISIV;
    }
    break;
  case 'V':
    if (memEQ(name, "PAM_SERVICE_ERR", 15)) {
    /*                      ^              */
      *iv_return = PAM_SERVICE_ERR;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_16 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     PAM_ACCT_EXPIRED PAM_AUTHTOK_TYPE PAM_CRED_EXPIRED PAM_CRED_UNAVAIL
     PAM_USER_UNKNOWN */
  /* Offset 15 gives the best switch position.  */
  switch (name[15]) {
  case 'D':
    if (memEQ(name, "PAM_ACCT_EXPIRE", 15)) {
    /*                              D      */
      *iv_return = PAM_ACCT_EXPIRED;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "PAM_CRED_EXPIRE", 15)) {
    /*                              D      */
      *iv_return = PAM_CRED_EXPIRED;
      return PERL_constant_ISIV;
    }
    break;
  case 'E':
    if (memEQ(name, "PAM_AUTHTOK_TYP", 15)) {
    /*                              E      */
      *iv_return = PAM_AUTHTOK_TYPE;
      return PERL_constant_ISIV;
    }
    break;
  case 'L':
    if (memEQ(name, "PAM_CRED_UNAVAI", 15)) {
    /*                              L      */
      *iv_return = PAM_CRED_UNAVAIL;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "PAM_USER_UNKNOW", 15)) {
    /*                              N      */
      *iv_return = PAM_USER_UNKNOWN;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_18 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     PAM_MODULE_UNKNOWN PAM_NO_MODULE_DATA PAM_PROMPT_ECHO_ON */
  /* Offset 4 gives the best switch position.  */
  switch (name[4]) {
  case 'M':
    if (memEQ(name, "PAM_MODULE_UNKNOWN", 18)) {
    /*                   ^                    */
      *iv_return = PAM_MODULE_UNKNOWN;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "PAM_NO_MODULE_DATA", 18)) {
    /*                   ^                    */
      *iv_return = PAM_NO_MODULE_DATA;
      return PERL_constant_ISIV;
    }
    break;
  case 'P':
    if (memEQ(name, "PAM_PROMPT_ECHO_ON", 18)) {
    /*                   ^                    */
      *iv_return = PAM_PROMPT_ECHO_ON;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(),
            {name=>"PAM_ABORT", type=>"IV", macro=>"1"},
            {name=>"PAM_ACCT_EXPIRED", type=>"IV", macro=>"1"},
            {name=>"PAM_AUTHINFO_UNAVAIL", type=>"IV", macro=>"1"},
            {name=>"PAM_AUTHTOK", type=>"IV", macro=>"1"},
            {name=>"PAM_AUTHTOK_DISABLE_AGING", type=>"IV", macro=>"1"},
            {name=>"PAM_AUTHTOK_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_AUTHTOK_EXPIRED", type=>"IV", macro=>"1"},
            {name=>"PAM_AUTHTOK_LOCK_BUSY", type=>"IV", macro=>"1"},
            {name=>"PAM_AUTHTOK_RECOVERY_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_AUTHTOK_TYPE", type=>"IV", macro=>"1"},
            {name=>"PAM_AUTH_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_BAD_ITEM", type=>"IV", macro=>"1"},
            {name=>"PAM_BUF_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_CONV", type=>"IV", macro=>"1"},
            {name=>"PAM_CONV_AGAIN", type=>"IV", macro=>"1"},
            {name=>"PAM_CONV_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_CRED_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_CRED_EXPIRED", type=>"IV", macro=>"1"},
            {name=>"PAM_CRED_INSUFFICIENT", type=>"IV", macro=>"1"},
            {name=>"PAM_CRED_UNAVAIL", type=>"IV", macro=>"1"},
            {name=>"PAM_ERROR_MSG", type=>"IV", macro=>"1"},
            {name=>"PAM_FAIL_DELAY", type=>"IV", macro=>"1"},
            {name=>"PAM_IGNORE", type=>"IV", macro=>"1"},
            {name=>"PAM_INCOMPLETE", type=>"IV", macro=>"1"},
            {name=>"PAM_MAXTRIES", type=>"IV", macro=>"1"},
            {name=>"PAM_MODULE_UNKNOWN", type=>"IV", macro=>"1"},
            {name=>"PAM_NEW_AUTHTOK_REQD", type=>"IV", macro=>"1"},
            {name=>"PAM_NO_MODULE_DATA", type=>"IV", macro=>"1"},
            {name=>"PAM_OLDAUTHTOK", type=>"IV", macro=>"1"},
            {name=>"PAM_OPEN_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_PERM_DENIED", type=>"IV", macro=>"1"},
            {name=>"PAM_PROMPT_ECHO_OFF", type=>"IV", macro=>"1"},
            {name=>"PAM_PROMPT_ECHO_ON", type=>"IV", macro=>"1"},
            {name=>"PAM_RHOST", type=>"IV", macro=>"1"},
            {name=>"PAM_RUSER", type=>"IV", macro=>"1"},
            {name=>"PAM_SERVICE", type=>"IV", macro=>"1"},
            {name=>"PAM_SERVICE_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_SESSION_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_SUCCESS", type=>"IV", macro=>"1"},
            {name=>"PAM_SYMBOL_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_SYSTEM_ERR", type=>"IV", macro=>"1"},
            {name=>"PAM_TEXT_INFO", type=>"IV", macro=>"1"},
            {name=>"PAM_TRY_AGAIN", type=>"IV", macro=>"1"},
            {name=>"PAM_TTY", type=>"IV", macro=>"1"},
            {name=>"PAM_USER", type=>"IV", macro=>"1"},
            {name=>"PAM_USER_PROMPT", type=>"IV", macro=>"1"},
            {name=>"PAM_USER_UNKNOWN", type=>"IV", macro=>"1"},
            {name=>"PAM_XAUTHDATA", type=>"IV", macro=>"1"},
            {name=>"PAM_XDISPLAY", type=>"IV", macro=>"1"});

print constant_types(), "\n"; # macro defs
foreach (C_constant ("PAM", 'constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("PAM", $types);
__END__
   */

  switch (len) {
  case 7:
    if (memEQ(name, "PAM_TTY", 7)) {
      *iv_return = PAM_TTY;
      return PERL_constant_ISIV;
    }
    break;
  case 8:
    /* Names all of length 8.  */
    /* PAM_CONV PAM_USER */
    /* Offset 7 gives the best switch position.  */
    switch (name[7]) {
    case 'R':
      if (memEQ(name, "PAM_USE", 7)) {
      /*                      R     */
        *iv_return = PAM_USER;
        return PERL_constant_ISIV;
      }
      break;
    case 'V':
      if (memEQ(name, "PAM_CON", 7)) {
      /*                      V     */
        *iv_return = PAM_CONV;
        return PERL_constant_ISIV;
      }
      break;
    }
    break;
  case 9:
    return constant_9 (aTHX_ name, iv_return);
    break;
  case 10:
    if (memEQ(name, "PAM_IGNORE", 10)) {
      *iv_return = PAM_IGNORE;
      return PERL_constant_ISIV;
    }
    break;
  case 11:
    return constant_11 (aTHX_ name, iv_return);
    break;
  case 12:
    return constant_12 (aTHX_ name, iv_return);
    break;
  case 13:
    return constant_13 (aTHX_ name, iv_return);
    break;
  case 14:
    return constant_14 (aTHX_ name, iv_return);
    break;
  case 15:
    return constant_15 (aTHX_ name, iv_return);
    break;
  case 16:
    return constant_16 (aTHX_ name, iv_return);
    break;
  case 18:
    return constant_18 (aTHX_ name, iv_return);
    break;
  case 19:
    /* Names all of length 19.  */
    /* PAM_AUTHTOK_EXPIRED PAM_PROMPT_ECHO_OFF */
    /* Offset 14 gives the best switch position.  */
    switch (name[14]) {
    case 'O':
      if (memEQ(name, "PAM_PROMPT_ECHO_OFF", 19)) {
      /*                             ^           */
        *iv_return = PAM_PROMPT_ECHO_OFF;
        return PERL_constant_ISIV;
      }
      break;
    case 'P':
      if (memEQ(name, "PAM_AUTHTOK_EXPIRED", 19)) {
      /*                             ^           */
        *iv_return = PAM_AUTHTOK_EXPIRED;
        return PERL_constant_ISIV;
      }
      break;
    }
    break;
  case 20:
    /* Names all of length 20.  */
    /* PAM_AUTHINFO_UNAVAIL PAM_NEW_AUTHTOK_REQD */
    /* Offset 6 gives the best switch position.  */
    switch (name[6]) {
    case 'T':
      if (memEQ(name, "PAM_AUTHINFO_UNAVAIL", 20)) {
      /*                     ^                    */
        *iv_return = PAM_AUTHINFO_UNAVAIL;
        return PERL_constant_ISIV;
      }
      break;
    case 'W':
      if (memEQ(name, "PAM_NEW_AUTHTOK_REQD", 20)) {
      /*                     ^                    */
        *iv_return = PAM_NEW_AUTHTOK_REQD;
        return PERL_constant_ISIV;
      }
      break;
    }
    break;
  case 21:
    /* Names all of length 21.  */
    /* PAM_AUTHTOK_LOCK_BUSY PAM_CRED_INSUFFICIENT */
    /* Offset 4 gives the best switch position.  */
    switch (name[4]) {
    case 'A':
      if (memEQ(name, "PAM_AUTHTOK_LOCK_BUSY", 21)) {
      /*                   ^                       */
        *iv_return = PAM_AUTHTOK_LOCK_BUSY;
        return PERL_constant_ISIV;
      }
      break;
    case 'C':
      if (memEQ(name, "PAM_CRED_INSUFFICIENT", 21)) {
      /*                   ^                       */
        *iv_return = PAM_CRED_INSUFFICIENT;
        return PERL_constant_ISIV;
      }
      break;
    }
    break;
  case 24:
    if (memEQ(name, "PAM_AUTHTOK_RECOVERY_ERR", 24)) {
      *iv_return = PAM_AUTHTOK_RECOVERY_ERR;
      return PERL_constant_ISIV;
    }
    break;
  case 25:
    if (memEQ(name, "PAM_AUTHTOK_DISABLE_AGING", 25)) {
      *iv_return = PAM_AUTHTOK_DISABLE_AGING;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

